;
;  This is include file
;

InFlag  db 0
CmdPhase db 0                   ; 0 - ceka se na Ctrl - Alt - ???
                                ; 1 - ceka se na 1-9

MoveIt: push cx si di ds es
        mov si,di
        mov di,bp

        mov ax,0B800h
        mov ds,ax
        push cs
        pop es
        rep movsw
        mov bp,di

        pop es ds di si cx

DoMoveIt:
        lodsb
        or al,al
        jz QMoveIt
        stosb
        mov al,bl
        stosb
        loop DoMoveIt
QMoveIt: retn

WaitKeys:
        sti
        mov bx,ReportFunc
        pusha
        push es
        xor ax,ax
        mov es,ax
@@1:    or bx,bx
        jz @@2

        pusha
        call DoReportFunc
        popa
        pusha
        push es

        mov ax,0B800h
        mov es,ax
        mov bl,1Fh
        mov di,startpos + 164
        mov si,dx
        mov cx,35
        call DoMoveIt

        pop es
        popa

@@2:    mov al,es:[417h]
        and al,09h
        cmp al,09h
        jne @@1
        pop es
        popa
        retn

;
; Error, vytiskne chybu / hlasku na cs:DX
;

Error:  push ds
        push es
        push dx
        push cs
        pop ds
        cld
        mov bl,17h
        mov ax,0B800h
        mov es,ax

        mov si,offset frame1
        mov di,startpos
        mov bp,offset buffer
        mov cx,40
        call moveit
        mov cx,40
        mov di,startpos + 160
        call moveit
        mov cx,40
        mov di,startpos + 160 + 160
        call moveit

        pop dx
        mov bl,1Fh
        mov di,startpos + 164
        mov si,dx
        mov cx,35
        call DoMoveIt

        call WaitKeys

        mov si,offset buffer
        mov di,startpos
        mov cx,40
        rep movsw
        mov cx,40
        add di,80
        rep movsw
        mov cx,40
        add di,80
        rep movsw

        pop es
        pop ds
        stc
        retn

;
; Number ax - cislo, cs:si - ukazuje na posledni cifru, bl - soustava
;

Number:
        div bl
        add ah,'0'
        mov cs:[si],ah
        dec si
        and ax,00FFh
        jnz Number
        retn

;
; Click - klikne
;

Click:  push ax
        in al,61h
	or al,3
	out 61h,al
	mov al,0B6h
	out 43h,al
	xor al,al
	out 42h,al
        mov ax,3000
@Loop:	dec ax
	jnz @Loop
	in al,61h
	and al,0FCh
	out 61h,al
        pop ax
	retn

IsIn    macro a,b,e
        local d
        cmp al,a
        jb d
        cmp al,b+1
        jnb d
        sub al,a
        add al,e
        jmp ScanOk
d:
        endm

;==============================================================================
;    The new interrupt handlers follow
;==============================================================================

;-- The new interrupt 09h handler (keyboard) ------------------------------

new09:
           sti                    ;Enable interrupts
           push ax                ;Store AX on the stack
           in   al,60h            ;Get scan code from the keyboard port

           cmp  al,128            ;Release code?
           jae  ik_end            ;Yes, do not test

           test CmdPhase,0FFh
           jz NoCmdPhase

           cmp al,2
           jb cancelCmd

           cmp al,11
           ja cancelCmd

           push ax
           mov al,20h
           out 20h,al
           pop ax
           dec al
           call StartCmd
           xor ax,ax
           mov CmdPhase,al
           pop ax
           iret

CancelCmd:
           push ax
           xor ax,ax
           mov CmdPhase,al
           pop ax

NoCmdPhase:
           ;-- Determine if the hotkey was activated -------------------

           push ax                ;Store DS and AX on the stack
           push ds

           mov  ax,0040h          ;Segment address of the BIOS segment to AX
           mov  ds,ax             ;and from there to DS
           mov  ax,ds:[17h]       ;Load BIOS keyboard flag
           and  ax,key_mask       ;Leave the bits from KeyMask
           cmp  ax,key_mask       ;Compare with KeyMask
           pop  ds                ;Restore DS and AX
           pop  ax

           jne  ik_end            ;No Hotkey ---> IK_END

           IsIn lo1 hi1 0
           IsIn lo2 hi2 4
           IsIn lo3 hi3 8
           jmp  ik_End

ScanOK:    test InFlag,255
           jnz ik_end
           inc InFlag

           push ax
           mov al,20h
           out 20h,al
           pop ax
           call HotKey        ;Start the TSR program

EOI:
           dec InFlag
           pop   ax               ;Restore the content of the AX register
           iret                   ;Return to the interrupted program

ik_end:
           pop ax
old09:     db 0EAh, 0,0,0,0
           ; call int9_ptr          ;Simulate INT 9h

HotKey:
        push bx cx
        mov bl,al
        xor bh,bh
        mov al,byte ptr cs:CmdTable[bx]
        mov CmdPhase,al

        mov bx,200h
        mov cx,100h
        call beep

        test CmdPhase,80h
        jz @@1

        call StartTsr
        xor ax,ax
        mov CmdPhase,al

@@1:    pop cx bx
        retn

